uses n2_image,n2_vector,n2_matrix,n2_mathe,pivtools2,sysutils,n2_complex,n2_transforms,n2_splines;

const bsx=384;
      bsy=384;
      ssx=256;
      ssy=256;
      
type tss=array of array of tsplineset;

var mus,mvs:tmatrix;
    mnxs,mxxs,mdxs,mnys,mxys,mdys:double;
    mue,mve:tmatrix;
    mnxe,mxxe,mdxe,mnye,mxye,mdye:double;
    muss,mvss:tmatrix;
    mues,mves:tmatrix;
    fo,fogpa,fogpb:text;
    c,l,i,j,k:longint;
    muec,mvec:tmatrixc;
    musc,mvsc:tmatrixc;
    sszu,ssnu:tmatrixc;
    sszv,ssnv:tmatrixc;
    vcxn,vcyn,vcxz,vcyz:tvectorc;
    vcx,vcy:tvector;
    vcxnu,vcynu,vcxzu,vcyzu:tvectorc;
    vcxu,vcyu:tvector;
    vcxnv,vcynv,vcxzv,vcyzv:tvectorc;
    vcxv,vcyv:tvector;
    ssu,ssv:tss;
    ssi:tvector;
    s2u,s2v,s2n,bx:double;

procedure pivuvload(s:string;var mu,mv:tmatrix;var mnx,mxx,mdx,mny,mxy,mdy:double);
var fi:text;
    x,y,u,v:double;
    vx,vy,vu,vv:tvector;
    i:longint;
procedure readlnxyuv(var x,y,u,v:double);
var si,sj:string;
    er:integer;
begin
  readln(fi,si);
  while (length(si)>0) and (not (si[1] in ['0'..'9','.','e','E','+','-'])) do si:=copy(si,2,length(si)-1);
  sj:='';
  while (length(si)>0) and (si[1] in ['0'..'9','.','e','E','+','-']) do
  begin
    sj:=sj+si[1];
    si:=copy(si,2,length(si)-1);
  end;
  val(sj,x,er);
  while (length(si)>0) and (not (si[1] in ['0'..'9','.','e','E','+','-'])) do si:=copy(si,2,length(si)-1);
  sj:='';
  while (length(si)>0) and (si[1] in ['0'..'9','.','e','E','+','-']) do
  begin
    sj:=sj+si[1];
    si:=copy(si,2,length(si)-1);
  end;
  val(sj,y,er);
  while (length(si)>0) and (not (si[1] in ['0'..'9','.','e','E','+','-'])) do si:=copy(si,2,length(si)-1);
  sj:='';
  while (length(si)>0) and (si[1] in ['0'..'9','.','e','E','+','-']) do
  begin
    sj:=sj+si[1];
    si:=copy(si,2,length(si)-1);
  end;
  val(sj,u,er);
  while (length(si)>0) and (not (si[1] in ['0'..'9','.','e','E','+','-'])) do si:=copy(si,2,length(si)-1);
  sj:='';
  while (length(si)>0) and (si[1] in ['0'..'9','.','e','E','+','-']) do
  begin
    sj:=sj+si[1];
    si:=copy(si,2,length(si)-1);
  end;
  val(sj,v,er);
end;
begin
  assign(fi,s);
  reset(fi);
  vx:=initv(0);
  vy:=initv(0);
  vu:=initv(0);
  vv:=initv(0);
  while not eof(fi) do
  begin
    readlnxyuv(x,y,u,v);
    setlength(vx,length(vx)+1);
    vx[length(vx)-1]:=x;
    setlength(vy,length(vy)+1);
    vy[length(vy)-1]:=y;
    setlength(vu,length(vu)+1);
    vu[length(vu)-1]:=u;
    setlength(vv,length(vv)+1);
    vv[length(vv)-1]:=v;
  end;
  close(fi);
//  write(length(vx),' ');
  write('*');
  mnx:=inf;
  mxx:=-inf;
  mdx:=inf;
  mny:=inf;
  mxy:=-inf;
  mdy:=inf;
  for i:=0 to length(vx)-1 do
  begin
    if vx[i]<mnx then mnx:=vx[i];
    if vx[i]>mxx then mxx:=vx[i];
    if (i>0) and (abs(vx[i]-vx[i-1])>0) and (abs(vx[i]-vx[i-1])<mdx) then mdx:=abs(vx[i]-vx[i-1]);
    if vy[i]<mny then mny:=vy[i];
    if vy[i]>mxy then mxy:=vy[i];
    if (i>0) and (abs(vy[i]-vy[i-1])>0) and (abs(vy[i]-vy[i-1])<mdy) then mdy:=abs(vy[i]-vy[i-1]);
  end;
  mu:=initm(round((mxy-mny)/mdy)+1,round((mxx-mnx)/mdx)+1);
  mv:=initm(round((mxy-mny)/mdy)+1,round((mxx-mnx)/mdx)+1);
  for i:=0 to length(vx)-1 do
  begin
    mu[round((vy[i]-mny)/mdy),round((vx[i]-mnx)/mdx)]:=vu[i];
    mv[round((vy[i]-mny)/mdy),round((vx[i]-mnx)/mdx)]:=vv[i];
  end;
end;

{
function getintu(x,y,mnx,mxx,mdx,mny,mxy,mdy:double;u:tmatrix):double;
var s,xi,yi:double;
    i,j,idx,idy:longint;
begin
  if (x>=mnx) and (x<=mxx) and (y>=mny) and (y<=mxy) then
  begin
    xi:=(x-mnx)/mdx;
    yi:=(y-mny)/mdy;
    idx:=maxi(4,mini(length(u[0])-4,floor(xi)));
    idy:=maxi(4,mini(length(u)-4,floor(yi)));
    s:=0;
    for j:=idy-4 to idy+3 do for i:=idx-4 to idx+3 do s:=s+u[j,i]*si(pi*(xi-i))*si(pi*(yi-j));
    getintu:=s;
  end;
end;
}

function getintu(x,y,mnx,mxx,mdx,mny,mxy,mdy:double;u:tmatrix;ss:tss):double;
var i,idx,idy:longint;
	xi,yi:double;
    va:tvector;
begin
  if (x>=mnx) and (x<=mxx) and (y>=mny) and (y<=mxy) then
  begin
    xi:=(x-mnx)/mdx;
    yi:=(y-mny)/mdy;
    idx:=maxi(0,mini(length(u[0])-8,floor(xi-4)));
    idy:=maxi(0,mini(length(u)-8,floor(yi-4)));
    va:=initv(8);
    for i:=0 to 7 do va[i]:=getsplineprep(ss[idy,idx+i],yi-idy);
    getintu:=getspline(va,xi-idx);
  end
  else getintu:=0;
end;

function stri(i:longint):string;
var s:string;
begin
  str(i,s);
  stri:=s;
end;

function det2(c11,c12,c21,c22:double):double;
begin
  det2:=c11*c22-c12*c21;
end;

function det3(c11,c12,c13,c21,c22,c23,c31,c32,c33:double):double;
begin
  det3:=c11*c22*c33+c12*c23*c31+c13*c21*c32-c11*c23*c32-c12*c21*c33-c13*c22*c31;
end;

function getbandwidth(y:tvector):boolean;
var s1,sx,sx2,sx3,sx4,sy,sxy,sx2y,a,b,c,ao,bo,co:double;
	i,j,k:longint;
begin
  getbandwidth:=false;
  a:=0;
  b:=0;
  c:=0;
  for k:=10 downto 2 do
  begin
    sx4:=0;
    sx3:=0;
    sx2:=0;
    sx:=0;
    s1:=0;
    sx2y:=0;
    sxy:=0;
    sy:=0;
    ao:=a;
    bo:=b;
    co:=c;
    for i:=k to length(y)-k-1 do
    begin
      if (y[i-k]>y[i]) and (y[i]>y[i+k]) and (y[i-k]>0.5) and (y[i+k]<0.5) and (abs(y[i]-0.5)<abs(y[i-k]-0.5)) and (abs(y[i]-0.5)<abs(y[i+k]-0.5)) then
      begin
        for j:=i-k to i+1 do
        begin
          s1:=s1+1;
          sx:=sx+j;
          sx2:=sx2+sqr(j);
          sx3:=sx3+sqr(j)*j;
          sx4:=sx4+sqr(sqr(j));
          sy:=sy+y[j];
          sxy:=sxy+j*y[j];
          sx2y:=sx2y+sqr(j)*y[j];
        end;
      end;
    end;
    if det3(sx4,sx3,sx2,sx3,sx2,sx,sx2,sx,s1)<>0 then
    begin
      a:=det3(sx2y,sx3,sx2,sxy,sx2,sx,sy,sx,s1)/det3(sx4,sx3,sx2,sx3,sx2,sx,sx2,sx,s1);
      b:=det3(sx4,sx2y,sx2,sx3,sxy,sx,sx2,sy,s1)/det3(sx4,sx3,sx2,sx3,sx2,sx,sx2,sx,s1);
      c:=det3(sx4,sx3,sx2y,sx3,sx2,sxy,sx2,sx,sy)/det3(sx4,sx3,sx2,sx3,sx2,sx,sx2,sx,s1);
      if (a=0) or (sqr(b)/4/sqr(a)-(c-0.5)/a<=0) then
      begin
        a:=ao;
        b:=bo;
        c:=co;
      end;
    end;
  end;
  if (a<>0) and (sqr(b)/4/sqr(a)-(c-0.5)/a>0) then
  begin
    bx:=-sgn(a)*sqrt(sqr(b)/4/sqr(a)-(c-0.5)/a)-b/2/a;
    getbandwidth:=true;
  end;
end;


begin
  assign(fogpa,'ts2_contesta.gpl');
  rewrite(fogpa);
  writeln(fogpa,'set term svg size 800,400 dashed enhanced fsize 9');
  writeln(fogpa,'set output "ts2_contesta.svg"');
  writeln(fogpa,'set logscale x');
  writeln(fogpa,'set xlabel "spatial frequency (pixel^{-1})"');
  writeln(fogpa,'set ylabel "response (-)"');
  writeln(fogpa,'set key outside');
  writeln(fogpa,'set label "^{1}/_{32}" at 0.03125,-0.6 center');
  writeln(fogpa,'set label "^{1}/_{16}" at 0.0625,-0.6 center');
  writeln(fogpa,'set label "^{1}/_{8}" at 0.125,-0.6 center');
  writeln(fogpa,'plot [] [] \');

  assign(fogpb,'ts2_contestb.gpl');
  rewrite(fogpb);
  writeln(fogpb,'set term svg size 990,400 dashed enhanced fsize 9');
  writeln(fogpb,'set output "ts2_contestb.svg"');
  writeln(fogpb,'set xlabel "bandwidth (pixel^{-1})"');
  writeln(fogpb,'set ylabel "error (pixel)"');
  writeln(fogpb,'set logscale xy');
  writeln(fogpb,'set key outside');
  writeln(fogpb,'set label "^{1}/_{32}" at 0.03125,0.0085 center');
  writeln(fogpb,'set label "^{1}/_{16}" at 0.0625,0.0085 center');
  writeln(fogpb,'plot [:] [:]\');

  for l:=3 to paramcount do
  begin
    muss:=initm(ssy,ssx);
    mvss:=initm(ssy,ssx);
    mues:=initm(ssy,ssx);
    mves:=initm(ssy,ssx);
    sszu:=initmc(ssy,ssx);
    ssnu:=initmc(ssy,ssx);
    sszv:=initmc(ssy,ssx);
    ssnv:=initmc(ssy,ssx);
    s2u:=0;
    s2v:=0;
    s2n:=0;
    
    for c:=0 to 199 do
    begin
      if fileexists(paramstr(1)+'/ts2_'+chr(ord('0')+c div 100)+chr(ord('0')+(c div 10) mod 10)+chr(ord('0')+c mod 10)+'.xyuv')
        and fileexists(paramstr(2)+paramstr(l)+'/ts2_'+chr(ord('0')+c div 100)+chr(ord('0')+(c div 10) mod 10)+chr(ord('0')+c mod 10)+'.xyuv') then
      begin
        
        pivuvload(paramstr(1)+'/ts2_'+chr(ord('0')+c div 100)+chr(ord('0')+(c div 10) mod 10)+chr(ord('0')+c mod 10)+'.xyuv',mus,mvs,mnxs,mxxs,mdxs,mnys,mxys,mdys);
        for j:=0 to length(mus)-1 do for i:=0 to length(mus[0])-1 do
        begin
          s2u:=s2u+sqr(mus[j,i]);
          s2v:=s2v+sqr(mvs[j,i]);
          s2n:=s2n+1;
        end;

        setlength(ssu,length(mus)-7,length(mus[0]));
        setlength(ssv,length(mvs)-7,length(mvs[0]));
        ssi:=initv(8);
        for j:=0 to length(mus)-8 do for i:=0 to length(mus[0])-1 do
        begin
          for k:=0 to 7 do ssi[k]:=mus[j+k,i];
          ssu[j,i]:=prepspline(ssi);
          for k:=0 to 7 do ssi[k]:=mvs[j+k,i];
          ssv[j,i]:=prepspline(ssi);
        end;
        
        for j:=0 to ssy-1 do for i:=0 to ssx-1 do
        begin
          muss[j,i]:=getintu(i+(bsx-ssx)/2+0.5,j+(bsy-ssy)/2+0.5,mnxs,mxxs,mdxs,mnys,mxys,mdys,mus,ssu);
          mvss[j,i]:=getintu(i+(bsx-ssx)/2+0.5,j+(bsy-ssy)/2+0.5,mnxs,mxxs,mdxs,mnys,mxys,mdys,mvs,ssv);
        end;
        
        pivuvload(paramstr(2)+paramstr(l)+'/ts2_'+chr(ord('0')+c div 100)+chr(ord('0')+(c div 10) mod 10)+chr(ord('0')+c mod 10)+'.xyuv',mue,mve,mnxe,mxxe,mdxe,mnye,mxye,mdye);
        
        setlength(ssu,length(mue)-7,length(mue[0]));
        setlength(ssv,length(mve)-7,length(mve[0]));
        ssi:=initv(8);
        for j:=0 to length(mue)-8 do for i:=0 to length(mue[0])-1 do
        begin
          for k:=0 to 7 do ssi[k]:=mue[j+k,i];
          ssu[j,i]:=prepspline(ssi);
          for k:=0 to 7 do ssi[k]:=mve[j+k,i];
          ssv[j,i]:=prepspline(ssi);
        end;
        
        for j:=0 to ssy-1 do for i:=0 to ssx-1 do
        begin
          mues[j,i]:=getintu(i+(bsx-ssx)/2+0.5,j+(bsy-ssy)/2+0.5,mnxe,mxxe,mdxe,mnye,mxye,mdye,mue,ssu);
          mves[j,i]:=getintu(i+(bsx-ssx)/2+0.5,j+(bsy-ssy)/2+0.5,mnxe,mxxe,mdxe,mnye,mxye,mdye,mve,ssv);
        end;
          
        musc:=ft(muss);
        mvsc:=ft(mvss);
        muec:=ft(mues);
        mvec:=ft(mves);

        for j:=0 to ssy-1 do for i:=0 to ssx-1 do
        begin
          sszu[j,i]:=addc(sszu[j,i],mulc(conj(muec[j,i]),musc[j,i]));
          ssnu[j,i]:=addc(ssnu[j,i],mulc(conj(musc[j,i]),musc[j,i]));
          sszv[j,i]:=addc(sszv[j,i],mulc(conj(mvec[j,i]),mvsc[j,i]));
          ssnv[j,i]:=addc(ssnv[j,i],mulc(conj(mvsc[j,i]),mvsc[j,i]));
        end;
      end;
    end;
    
    vcx:=initv(ssx);
    vcy:=initv(ssy);
    vcxn:=initvc(ssx);
    vcyn:=initvc(ssy);
    vcxz:=initvc(ssx);
    vcyz:=initvc(ssy);
    vcxu:=initv(ssx);
    vcyu:=initv(ssy);
    vcxnu:=initvc(ssx);
    vcynu:=initvc(ssy);
    vcxzu:=initvc(ssx);
    vcyzu:=initvc(ssy);
    vcxv:=initv(ssx);
    vcyv:=initv(ssy);
    vcxnv:=initvc(ssx);
    vcynv:=initvc(ssy);
    vcxzv:=initvc(ssx);
    vcyzv:=initvc(ssy);

    for j:=0 to ssy-1 do for i:=0 to ssx-1 do
    begin
      vcxn[i]:=addc(vcxn[i],addc(ssnu[j,i],ssnv[j,i]));
      vcxz[i]:=addc(vcxz[i],addc(sszu[j,i],sszv[j,i]));
      vcyn[j]:=addc(vcyn[j],addc(ssnu[j,i],ssnv[j,i]));
      vcyz[j]:=addc(vcyz[j],addc(sszu[j,i],sszv[j,i]));
      vcxnu[i]:=addc(vcxnu[i],ssnu[j,i]);
      vcxzu[i]:=addc(vcxzu[i],sszu[j,i]);
      vcynu[j]:=addc(vcynu[j],ssnu[j,i]);
      vcyzu[j]:=addc(vcyzu[j],sszu[j,i]);
      vcxnv[i]:=addc(vcxnv[i],ssnv[j,i]);
      vcxzv[i]:=addc(vcxzv[i],sszv[j,i]);
      vcynv[j]:=addc(vcynv[j],ssnv[j,i]);
      vcyzv[j]:=addc(vcyzv[j],sszv[j,i]);
    end;
    for i:=0 to ssx-1 do vcx[i]:=divc(vcxz[i],vcxn[i]).re;
    for j:=0 to ssy-1 do vcy[j]:=divc(vcyz[j],vcyn[j]).re;
    for i:=0 to ssx-1 do vcxu[i]:=divc(vcxzu[i],vcxnu[i]).re;
    for j:=0 to ssy-1 do vcyu[j]:=divc(vcyzu[j],vcynu[j]).re;
    for i:=0 to ssx-1 do vcxv[i]:=divc(vcxzv[i],vcxnv[i]).re;
    for j:=0 to ssy-1 do vcyv[j]:=divc(vcyzv[j],vcynv[j]).re;

    vcxn:=initvc(ssx);
    vcyn:=initvc(ssy);
    vcxz:=initvc(ssx);
    vcyz:=initvc(ssy);
    vcxnu:=initvc(ssx);
    vcynu:=initvc(ssy);
    vcxzu:=initvc(ssx);
    vcyzu:=initvc(ssy);
    vcxnv:=initvc(ssx);
    vcynv:=initvc(ssy);
    vcxzv:=initvc(ssx);
    vcyzv:=initvc(ssy);

    for j:=0 to ssy-1 do for i:=0 to ssx-1 do
    begin
      vcxn[i]:=addc(vcxn[i],mulc(addc(ssnu[j,i],ssnv[j,i]),vcy[j]));
      vcxz[i]:=addc(vcxz[i],mulc(addc(sszu[j,i],sszv[j,i]),vcy[0]));
      vcyn[j]:=addc(vcyn[j],mulc(addc(ssnu[j,i],ssnv[j,i]),vcx[i]));
      vcyz[j]:=addc(vcyz[j],mulc(addc(sszu[j,i],sszv[j,i]),vcx[0]));
      vcxnu[i]:=addc(vcxnu[i],mulc(ssnu[j,i],vcyu[j]));
      vcxzu[i]:=addc(vcxzu[i],mulc(sszu[j,i],vcyu[0]));
      vcynu[j]:=addc(vcynu[j],mulc(ssnu[j,i],vcxu[i]));
      vcyzu[j]:=addc(vcyzu[j],mulc(sszu[j,i],vcxu[0]));
      vcxnv[i]:=addc(vcxnv[i],mulc(ssnv[j,i],vcyv[j]));
      vcxzv[i]:=addc(vcxzv[i],mulc(sszv[j,i],vcyv[0]));
      vcynv[j]:=addc(vcynv[j],mulc(ssnv[j,i],vcxv[i]));
      vcyzv[j]:=addc(vcyzv[j],mulc(sszv[j,i],vcxv[0]));
    end;
    for i:=0 to ssx-1 do vcx[i]:=divc(vcxz[i],vcxn[i]).re;
    for j:=0 to ssy-1 do vcy[j]:=divc(vcyz[j],vcyn[j]).re;
    for i:=0 to ssx-1 do vcxu[i]:=divc(vcxzu[i],vcxnu[i]).re;
    for j:=0 to ssy-1 do vcyu[j]:=divc(vcyzu[j],vcynu[j]).re;
    for i:=0 to ssx-1 do vcxv[i]:=divc(vcxzv[i],vcxnv[i]).re;
    for j:=0 to ssy-1 do vcyv[j]:=divc(vcyzv[j],vcynv[j]).re;

    assign(fo,'ts2_'+paramstr(l)+'.resx');
    rewrite(fo);
    for i:=0 to ssx div 2 do writeln(fo,i/ssx,' ',vcx[i]);
    close(fo);
    assign(fo,'ts2_'+paramstr(l)+'.resy');
    rewrite(fo);
    for j:=0 to ssy div 2 do writeln(fo,j/ssy,' ',vcy[j]);
    close(fo);

    writeln(fogpa,'"ts2_'+paramstr(l)+'.resx" title "'+paramstr(l)+' (x direction)" w l lt 1 lc '+stri(l-2)+',"ts2_'+paramstr(l)+'.resy" title "'+paramstr(l)+' (y direction)" w l lt 2 lc '+stri(l-2)+',\');

    assign(fo,'ts2_'+paramstr(l)+'.bwer');
    rewrite(fo);
    if getbandwidth(vcxu) then writeln(fo,bx/ssx,' ',sqrt(s2u/s2n)*abs(1-vcxu[0]));
    if getbandwidth(vcyu) then writeln(fo,bx/ssy,' ',sqrt(s2u/s2n)*abs(1-vcyu[0]));
    if getbandwidth(vcxv) then writeln(fo,bx/ssx,' ',sqrt(s2v/s2n)*abs(1-vcxv[0]));
    if getbandwidth(vcyv) then writeln(fo,bx/ssy,' ',sqrt(s2v/s2n)*abs(1-vcyv[0]));
    close(fo);

    writeln(fogpb,'"ts2_'+paramstr(l)+'.bwer" title "'+paramstr(l)+' (x/u, x/v, y/u and y/v direction/component)" w p pt '+stri(l-2)+',\');

    writeln;

  end;
  writeln(fogpa,'"-" notitle w l lt 0');
  writeln(fogpa,'0.03125 -0.5');
  writeln(fogpa,'0.03125 1.5');
  writeln(fogpa);
  writeln(fogpa,'0.0625 -0.5');
  writeln(fogpa,'0.0625 1.5');
  writeln(fogpa);
  writeln(fogpa,'0.125 -0.5');
  writeln(fogpa,'0.125 1.5');
  writeln(fogpa,'e');
  close(fogpa);
  
  writeln(fogpb,'"-" notitle w l lt 0');
  writeln(fogpb,'0.03125 0.01');
  writeln(fogpb,'0.03125 1');
  writeln(fogpb);
  writeln(fogpb,'0.0625 0.01');
  writeln(fogpb,'0.0625 1');
  writeln(fogpb,'e');
  close(fogpb);

end.
